/***********************************************************************/
/*  PROJECT		:tbVROM݃c[vO			   */
/*	FUNCTION    :SDް ǂݍ݁AޯϲްM               */
/*  FILE        :fwrite.c                                              */
/*  DATE        :May 10, 2007		                                   */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :R8C/15 Tiny                                           */
/*  AUTHOR      :HIDEO NAKAMURA                                        */
/***********************************************************************/
                  
#include	"sfr_r815.h"
#include	"lcd.h"

/* ------- MMC/SD J[h֘A ----- */

#define 	CS_SD_D	pd3_5		// R8 chip select ݒ背WX^
#define 	CS_SD	p3_5		// 
#define 	CLK_D	pd4_5		//  
#define 	CLK		p4_5		// clock
#define 	D_OUT	p1_7		// Data Out
#define 	D_IN_D	pd3_7		// SDDataIn, R8Out
#define 	D_IN	p3_7		// 

#define		FILE_NAME_MAX	12	// ő t@C޲Đ
#define		DATA_ADD_MAX	5	// ő ݃f[^擪AhX ޲Đ
	
/* ----------ϐ` ------------ */
unsigned char 	Buffer1[20];			//LCDi[pobt@
unsigned char   DataBuff[32];   		// f[^obt@
unsigned char   ProgName[FILE_NAME_MAX];   		// ݐvO t@C 8+1+3=11
unsigned char   FileName[FILE_NAME_MAX];   		// ݃f[^t@C 8+1+3=12
unsigned char   StartAddHex[DATA_ADD_MAX];   			// ݃f[^擪AhX 5
unsigned char   FATtype;        		// 0:FAT12  1:FAT16
unsigned char   SectorsPerCluster;      // 1NX^̃ZN^
unsigned int    RootDirEntriesCount;    // [gfBNgGg[
unsigned int    FATstart;       		// FATJnZN^
unsigned int    FATsize;        		// PFAT̃ZN^
unsigned int    DIRstart;       		// [gfBNgJnZN^
unsigned long   DataStart;      		// f[^̈JnZN^
unsigned long   ClusterNum;				// (?long ) FATGg̃t@Ĉ׽ʒu 070228
unsigned long   ClusterChainNum;		// size 2byte 070404
unsigned long 	DataSize;				// ݃f[^TCY070313
unsigned long 	StartAdd;				// ݐ擪ڽ
unsigned char   ReadFlag=0;				// ǂݍݒtO 070306

/* -------- ֐vg^Cv ----------*/
unsigned char SPI_in2(void);
unsigned char SD_Init(void);
unsigned char SPI_command(unsigned char com, unsigned long arg);
unsigned char SPI_in(void);
void SPI_out2(unsigned char data);
unsigned char read_FAT_info(void);
void read_32(unsigned long addr);
unsigned char SPI_read_open(unsigned long adrs);
void SPI_read_close(void);
unsigned int search_file(unsigned char *str);
void read_sect(unsigned long adrs);
void read_sect_dat(unsigned long addr,unsigned char num);
void UART0_tx(unsigned char data);
long hexsz2int(char *str);
unsigned char read_32add512(unsigned long addr, unsigned char cnt);

//****************************************************************
// 16i10iɕϊ
//****************************************************************
// 	   str 16iASCII
//@@     擪ɕt͑ΉȂBe0`9AA`FA܂́Aa`f
long hexsz2int(char *str)
{
    long val;
    
    while (*str == ' ') str++;	// skip space
    val = 0;
    while (*str >= '0' && *str <= '9' ||
           *str >= 'A' && *str <= 'F' ||
           *str >= 'a' && *str <= 'f') {
        val <<= 4;
        if      (*str >= '0' && *str <= '9') val += *str - '0';
        else if (*str >= 'A' && *str <= 'F') val += *str - 'A' + 10;
        else                                 val += *str - 'a' + 10;
        str++;
    }

    return val;
}

//*********************************************************
//  CPUNbN ݒ蕔
//*********************************************************
void Init_Clock(void){
	prc0 = 1;						//veNg
	// NbNgp 20MHz
	cm13 = 1; 						// Xin-Xout[q؂ւ
	cm05 = 0; 						// Xin-XoutCNbNU
	cm06 = 0; 						// 8ȊO(Ȃ)
	asm("nop");						// Ü҂
	asm("nop");						// ij
	asm("nop");						// ij
	asm("nop"); 					// ij
	ocd2 = 0; 						// CNbNI
	prc0 = 0;						// veNgI
}

//*********************************************************
//  SDJ[hԒʐM ʏ|[ggp
//*********************************************************
void Init_SD_Serial(void){

	// VA UART0 NbN[hݒ
	u0mr = 0x05;		// UART0M[hWX^ UARTӰ ް8ޯ
	u0brg =64;			// 19200 bps ׋Z '05 5 p.152
//	u0brg =32;			// 38400 bps ׋Z '05 5 p.152
	te_u0c1 =1;      	/* MꍇAg1h */

	CS_SD_D = 1;			// CS o̓[hݒ; chip select R8

	pd1_4 = 1;			// TxdޯĐݒ
	pd1_5 = 0;			// RxdޯĐݒ

 	D_IN_D =1;			// SDDataIn, port Out
 	CLK_D = 1;			// port Out 
 	CLK =1;				// o=Lo

}

//*********************************************************
//  SDJ[hԒʐM ʏ|[ggp
//*********************************************************
void SetSci38400(void){
	te_u0c1 =0;      	/* Ms */
	re_u0c1 =0;      	/* Ms */
	u0brg =32;			// 38400 bps ׋Z '05 5 p.152

	te_u0c1 =1;
	re_u0c1 =1;
}

//*********************************************************
//  MMC/SDJ[h̏
//*********************************************************
unsigned char SD_Init(void){
    unsigned char c=0;

    CS_SD = 1;						// chip select

    // MMC/SD SPI[hڍsÕNbNM
    for (c=0; c < 20; c++){			// MMCCjVCYp̃_~[NbN74NbNȏ㔭s
        SPI_in2();					// 1byte data read
    }

    // SPI[hڍsR}h
	CS_SD = 0; 						// chip select

    do{
        c = SPI_command(0, 0);		// CMD0𑗐M1M
    }while (c !=1);

    do{
        c = SPI_command(1, 0);		// CMD1𑗐MA1MȂ
		if ((c !=0)&&(c !=1)){
			c = 0xff;				// error
			break;
		}
    }while (c == 1);				// 0ɂȂ܂őB

    CS_SD = 1; 

    return c;
}

//****************************************
//  MMC/SD SPIR}ho
//****************************************
unsigned char SPI_command(unsigned char com, unsigned long argmnt){
    unsigned int    i;
    unsigned char   r;

    for (i = 0; i < 1000; i++){
        r = SPI_in2();
        if (r == 0xFF){
          break;					// DO[qHiɂȂ܂ő҂
		}
    }
    if (r != 0xFF)  return 0xFF;	// ѱ
    SPI_out2(com|0x40);
    SPI_out2(argmnt >> 24);
    SPI_out2(argmnt >> 16);
    SPI_out2(argmnt >> 8);
    SPI_out2(argmnt);
    if (com != 24){
        SPI_out2(0x95);  			//R}hCRC"0x95"
        for(i = 0; i < 1000; i++){
            r = SPI_in2();			// X|Xl
            if (r == 0xFE)   break;
            if (!(r & 0x80)){		// l킩fBȃX|XMSB"0"
                SPI_in2();
                break;
            }
        }
    } else {
        r = SPI_in2();  			// R}hȊÕ_~[CRC
    }
    return r;
}

//*********************************************************
//  FATǂݎ
//*********************************************************
unsigned char read_FAT_info(void){
    unsigned long   sec;
    unsigned int    bpb;
    unsigned int    n;

    // FATǂݎBZN^ 512Bytes
    read_32(446);                                       // MasterBootRecord̃p[eBVe[uǂݍ
    if ( (DataBuff[0]==0x00)||(DataBuff[0]==0x80) ){	// ӁI0x80;߰èݱè
        bpb = (unsigned int)DataBuff[8] + ((unsigned int)DataBuff[9]<<8);   // BPB擪ZN^
    } else {
        read_32(0);                                     // MBRǂݍ MBȐꍇ
        bpb = 0;										// 0́AϽްںނ݂ȂꍇB
    }

	// u[gZN^ǂݍ
    read_32((unsigned long)bpb * 512);        		    // ްľ
    n = (unsigned int)DataBuff[11] + ((unsigned int)DataBuff[12] << 8); //oCg/ZN^
    if (n != 512){
        return 2;   // 1ZN^ 512bytesłȂ
    }
    SectorsPerCluster = DataBuff[13];       			// 1NX^̃ZN^ ω
	FATstart = bpb + (unsigned int)DataBuff[14] + ((unsigned int)DataBuff[15] << 8);// FATJnZN^
    RootDirEntriesCount = (unsigned int)DataBuff[17]
        + ((unsigned int)DataBuff[18] << 8);        	// [gfBNgGg
    n = (unsigned int)DataBuff[22] + ((unsigned int)DataBuff[23] << 8); // ZN^/1FAT
    if (n == 0){
        return 1;   // ΉFAT
    }
    FATsize = (unsigned int)DataBuff[16] * n;       	//FAT̑ZN^ FAT̐~ZN^
    DIRstart = (unsigned int)FATstart + FATsize; 		//ٰިڸ؊JnZN^    
    n = RootDirEntriesCount / 16;   					// [gfBNgɕKvȃZN^
    DataStart = (unsigned long)DIRstart + (unsigned long)n;     // f[^i[̈

    sec = (unsigned long)DataBuff[19] + ((unsigned long)DataBuff[20] << 8); // ZN^
    if (sec == 0){
        read_32((unsigned long)bpb * 512 + 32);     	// ǂݍ
        sec = (unsigned long)DataBuff[0] + ((unsigned long)DataBuff[1] << 8)
            + ((unsigned long)DataBuff[2] << 16) + ((unsigned long)DataBuff[3] << 24);
    }
    sec -= FATstart;
    sec /= SectorsPerCluster;
    if (sec >= 0x1000){
        FATtype = 1;    // FAT16
    } else {
        FATtype = 0;    // FAT12
    }

    return 0;
}

//****************************************
//  MMC/SDJ[h 32byteǂ DataBuffɊi[
//  AhX512byteP
//****************************************
unsigned char read_32add512(unsigned long addr, unsigned char cnt){ // addr;*512Pʤcnt=16=512/32
    unsigned int   i;

	if (cnt ==0){
	    i = SPI_read_open(addr & 0xFFFFFE00);	// 512byte P
		if (i) return i;	// =================> can't open
	}

    for (i = 0; i < 32; i++){
        DataBuff[i] = SPI_in2();
    }

	if (cnt ==15){			// end of read
	    SPI_read_close();
	}
	return 0;				// I
}

//****************************************
//  MMC/SDJ[h 32byteǂ DataBuffɊi[
//****************************************
void read_32(unsigned long addr){ // addr;*512+w޲Ė
    unsigned int  i, b;

    if (SPI_read_open(addr & 0xFFFFFE00)){
	   return;
	}
    b = (unsigned int)addr & 0x01FF;
    for (i=0; i < 512; i++){
        if (i == b){
            int n;
            for (n = 0; n < 32; n++){
                DataBuff[n] = SPI_in2();
                i++;
            }
        } else {
            SPI_in2();
        }
    }
    SPI_read_close();
}
//*********************************************************
//  t@C{
//  Ft@CF8ȓ+"."+3ȓ
//  ߂lFerr
//*********************************************************
unsigned int search_file(unsigned char *str){
    unsigned int    ent;
    unsigned long   sec;
    unsigned char   i, j, k;
    unsigned int    n;
	unsigned int    err;
	unsigned char *stmp;

    n = 0;
	err = 1;				// G[
	if (*str ==0) return 1;	// ========================> f[^Ȃ
    sec = (unsigned long)DIRstart * 512;	// [gfBNgJnZN^;512byteP
    for (ent = 0; ent < RootDirEntriesCount; ){
        if (SPI_read_open(sec)) return 2;	// =========================>
        for (i = 0; i < 16; i++){
            for (j = 0; j < 32; j++){
                DataBuff[j] = SPI_in2();
            }

            if (DataBuff[0] == 0) continue;  	// skip j++ gp̈挟o
            if (DataBuff[0] == 0xE5) continue;  // 폜}[N
            if (DataBuff[11] & 0x18) continue;  // ʏt@CłȂ
			stmp = str;

			for (k=0; k < 11; k++){				// 11=8:name + 3:extension
				if (*stmp == '.'){
					k = 7;
				}else if (k == 10 ){			// (=0to7+3) end of data
					if (DataBuff[k] == *stmp){
						err =0;					// G[Ȃ t@C擾
					}
				}else{
					if (DataBuff[k] != *stmp){	// sv
						break;					// check next file
					}
				}
				stmp++;
			}

			if ( err == 0){						// G[Ȃ t@C擾
				ClusterNum = ((unsigned long)DataBuff[21]<<24)+ ((unsigned long)DataBuff[20]<<16)+
							 ((unsigned long)DataBuff[27]<<8 )+ DataBuff[26];
				ClusterChainNum = ClusterNum;
				DataSize = DataBuff[28] + ((unsigned long)DataBuff[29]<<8)+
							((unsigned long)DataBuff[30]<<16 )+ ((unsigned long)DataBuff[31]<<24);
                n++;
               break;
            }
            ent++;
        }

        SPI_read_close();
        if (n != 0) break;						// t@CAI
        sec += 512; 							// ̃ZN^
    }
    return err;
}

//****************************************
//  MMC/SDJ[hǂݍ݃I[v
//****************************************
unsigned char SPI_read_open(unsigned long adrs){
    unsigned int    i;
    unsigned char   r;
    unsigned char   retry;

    for (retry = 0; retry < 100; retry++){
	    CS_SD = 0;
        r = SPI_command(17, adrs);
        if (r == 0){
            for (i = 0; i < 4000; i++){
                r = SPI_in2();
                if (r == 0xFE){
                    return 0;   // ]Jn}[N
                }
            }
        } else if (r == 0xFE){
            return 0;   		// I[v
        }
	    CS_SD = 1;
    }
    return 1;   				// I[vo
}
//****************************************
//  MMC/SDJ[hǂݍ݃N[Y
//****************************************
void SPI_read_close(void){
    unsigned int    i;

    SPI_in2();
    SPI_in2();
    // BUSY`FbN
    for (i = 0; i < 1000; i++){
        if (SPI_in2() == 0xFF)   break;
    }
    CS_SD = 1;
}

//****************************************
//  MMC/SD SPIf[^
//****************************************
unsigned char SPI_in2(void){
	unsigned char tmp;
	int i,j;

	tmp =0;
	for (i=0; i<16; i++){
		CLK ^=1;				// o=Lo
		if ((i & 0x01)==1){		// CLK オ莞߰Read
			tmp |= D_OUT<< (7-(i/2)); 
		}else{
			for (j=0; j<5; j++){
				asm("nop");		// Ԓ; Ăǂ
			}
		}
	}

	for (j=0; j<10; j++){
		asm("nop");				// Ԓ; Ăǂ
	}
	return tmp;					// Mް
}

//****************************************
//  MMC/SD SPIf[^o
//****************************************
void SPI_out2(unsigned char data){
	int i,j;

	D_IN = 1;					// o͑OHiɂB
	for (i=0; i<16; i++){
		CLK ^=1;				// o=Lo
		if ((i & 0x01)==0){		// CLK莞߰ďo
			D_IN = (data >> (7-(i/2)) ) & 0x01;
		}else{
			for (j=0; j<5; j++){
				asm("nop");		// Ԓ; Ăǂ
			}
		}
	}
	D_IN = 1;					// o͌HiɂB

	for (j=0; j<10; j++){
		asm("nop");				// Ԓ; Ăǂ
	}
}

//****************************************
//  UART0 1byteM ^CAEgFloop񐔑҂
//****************************************
short UART0_rx(int loop)
{
	short	data;
	char 	err;
	int i;
	
	i=0;
	if (!loop){						// ƎM҂
		while( ri_u0c1 !=1);
	}else{							// loop M҂
		while( ri_u0c1 !=1){
			if (i++ > loop) return 	0xfffe; // ===========>END
		}
	}
	data = 0x00ff & u0rbl;			//  u0rbl̍Ō㕶L̏
	err = u0rbh & 0xf0;
	if (err != 0){
		re_u0c1 =0;     	/* 0:Ms oer;ݴװ̸ر͎M֎~ݒKv */
    	oer_u0rb =0;   	  	/* Overrun error flag */
    	fer_u0rb =0;     	/* Framing error flag */
    	per_u0rb =0;     	/* Parity error flag */
		data = u0rbl;		// dummy read
		re_u0c1 =1;      	/* M */
	}
	return data;
}

//****************************************
//  UART0 1byteM
//****************************************
void UART0_tx(unsigned char data)
{
	while( ti_u0c1 !=1);		// ް ]҂
	u0tb = data;				// Mޯ̧ް
}

//****************************************
//  UART0 񑗐M
//****************************************
void UART0_tx_str(unsigned char *str, unsigned char num)
{
	int i, j;
	for ( i=0; i< num; i++ ){
		for (j =0; j < 1000; j++) asm("nop");	// MԊu
		UART0_tx(*str);
		str++;
	}
}

//**************************************************
//  UART2 ݐ۸ёMI mFM 070327
//**************************************************
unsigned char RcvProgSendEnd(void)
{
	unsigned short stmp;

	stmp = UART0_rx(0);	// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0xAA){	// 0xAAM(170) H8tbV̑Sf[^ꂽƂmF
		return 0;		// Not found
	}else{
		return 1;		// Find and End
	}
}

//**************************************************
//  ݏt@C̃f[^ǂݍ 070402
//**************************************************
void FileRead(void)
{
	unsigned long ultmp;
	unsigned char i,j;
	unsigned char num;

	ultmp = (unsigned long)(DataStart+(ClusterNum-2)*SectorsPerCluster)*512;
	read_32( (unsigned long)ultmp );
	
	for (i=0; i< FILE_NAME_MAX ; i++){
		ProgName[i] = 0;		// zero clear
		FileName[i] = 0;
	}
	for (i=0; i< DATA_ADD_MAX ; i++){
		StartAddHex[i] =0;
	}
	num =0;
	j=0;
	for (i=0; i< 32 ; i++){
		if ((DataBuff[i]== 0x0D)&&(DataBuff[i+1]==0x0A)){	// Windows s
			num ++;
			i++;		// skip to next string data
			j =0;
		}else{
			switch (num){
			
			case 0:
				if (j< FILE_NAME_MAX){			// ő啶
					ProgName[j] = DataBuff[i];
				}
				break;
			case 1:
				if (j< FILE_NAME_MAX){			// ő啶
					FileName[j] = DataBuff[i];
				}
				break;
			case 2:
				if ((DataBuff[i] == 'H')||(DataBuff[i] == 'h')){
					i = 32;						// for loop End
				}else{
					if (j< DATA_ADD_MAX){		// ő啶 
						StartAddHex[j] = DataBuff[i];
					}
				}
				break;
			}
			j++;
		}
	}


	StartAdd = hexsz2int(StartAddHex);
}

//**************************************************
//  ̃NX^ԍǂݍ
//**************************************************
void ReadClusterChain(unsigned long *cluster)
{
	unsigned long ultmp;

	// ŏt@CP=SectorsPerCluster*512byteA512͌Œ  ㎮̊ʈʒuɒ
	read_32( (unsigned long)(FATstart)*512 + (*cluster/16*32) ); 	// data read

	*cluster = (unsigned long)DataBuff[(*cluster % 16)*2] + (unsigned long)DataBuff[(*cluster % 16)*2 +1]*256;
}


/*//////////////////////////////////////////////////////////////*/
/* 		C[` 											*/
/*//////////////////////////////////////////////////////////////*/
void main(void){

	unsigned char res;
	unsigned int  temp;
	unsigned long ultmp;
	int i;
	short	stmp;
	unsigned long send;
	unsigned long send_cluster;

	Init_Clock();
	Init_SD_Serial();
	Init_LCD();						// LCDpCPU֐

	/// LCDbZ[W
	lcd_init();						// LCD
	lcd_str("START \0");				// bZ[W
	res = SD_Init();				// ]ubN32rbgɕύX
	lcd_str("SDInitOK\0");
	
	res = read_FAT_info();
	if (res){
		lcd_cmd(0xC0);				//Qs
		lcd_str("FAT_ERR=\0");		// װԍ\
		ltostring(1, res, Buffer1);
		lcd_str(Buffer1);
		while(1);	// ===================> loop
    }

	/////////////////////////////////////
	// ݏt@CT
	/////////////////////////////////////

	temp = search_file("H8S.INI");
	if (temp==1){							// file not found
		lcd_str("FileNotFound\0");
		while(1);	// ===================> loop
	}else{
		FileRead();							// file data read
	}

	temp = search_file(ProgName);			// ݐvO T

	i=0;
	ultmp = (unsigned long)(DataStart+(ClusterNum-2)*SectorsPerCluster)*512 +i*32;	// address
	read_32( (unsigned long)ultmp );  // data read


	/* H8 u[g tbVݐvO] */
	re_u0c1 =1;      				/* MꍇAg1h */

	/*rbg[g킹*/
	do{
		UART0_tx(0);				// SCIrbg[g킹ݗp f[^M
		stmp = UART0_rx(100);		// 100:timeOut 480us ,0͂Ƒ҂
	}while(stmp !=0);				// ޯڰĒI 0x00 M

	lcd_cmd(0x02);					// Cursor At Home
	lcd_str("BpsSetOK\0");

	UART0_tx(0x55);					// 0x55M R8C -> H8
	stmp = UART0_rx(0);				// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0xAA){				// 0xAAM Error
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error1\0");		// Error \
	}
									/* ݐvÕoCg */
	UART0_tx(DataSize >> 8);		// MoCg ʃoCgM
	stmp = UART0_rx(0);				// ޯ (0)͂Ƒ҂
	if (stmp != (DataSize >> 8)){	// Error
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error2\0");
	}

	UART0_tx(DataSize & 0xff);		// ʃoCgM
	stmp = UART0_rx(0);				// ޯ (0)͂Ƒ҂
	if (stmp != (DataSize & 0xff)){	// Error
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error3\0");
	}

	re_u0c1 =0;      				/* 0:Ms */

	ultmp = (unsigned long)(DataStart+(ClusterNum-2)*SectorsPerCluster)*512;	// address
	send =0;
	send_cluster =0;
	while ( send < DataSize ){			// rootdirectory瓾t@CTCY
		for (i=0; i<16; i++){
			if (send_cluster >= (SectorsPerCluster*512)){	// f[^1NX^TCY
				send_cluster =0;
				ReadClusterChain(&ClusterChainNum);			// NX^`F[T
				ultmp = (unsigned long)(DataStart+(ClusterChainNum-2)*SectorsPerCluster)*512;
			}

			if (read_32add512( ultmp, i)){	// AhX:512byte PʁAǍ32byte
				lcd_cmd(0x02);				// Cursor At Home
				lcd_str("Error4\0");
				while(1);	// ======================================> loop
			}
			if ( (DataSize - send) <= 32){
				stmp = DataSize - send;
			}else{
				stmp = 32;
			}
			UART0_tx_str(DataBuff, stmp);
			send_cluster += stmp;
			send += stmp;

			if (send == DataSize){			// ۸ёMI
				re_u0c1 =1;      			/* 1:M */
				while (!RcvProgSendEnd());	// ܂Loop
				break;
			}
		}
		ultmp += 512;
	}
	
	///////////////////////////////////////
	// H8݃vON
	///////////////////////////////////////

	SetSci38400();

	stmp = UART0_rx(0);	// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0x41){	// 0x41M
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error5\0");
		while(1);	// ======================================> loop
	}

	UART0_tx(0x41);		// 0x41M R8C -> H8

	stmp = UART0_rx(0);	// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0x00){	// 0x00M
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error6\0");
		while(1);	// ======================================> loop
	}

	// ݃f[^t@CT
	temp = search_file(FileName);				// 070312

	// H8S  ݐ擪AhXA4޲đM
	Buffer1[0]= (StartAdd >> 24)& 0xFF;
	Buffer1[1]= (StartAdd >> 16)& 0xFF;
	Buffer1[2]= (StartAdd >>  8)& 0xFF;
	Buffer1[3]= (StartAdd )& 0xFF;
	Buffer1[4]= 0;
	UART0_tx_str(Buffer1, 4);
	// ݻށ@A4޲đM
	Buffer1[0]= (DataSize >> 24)& 0xFF;
	Buffer1[1]= (DataSize >> 16)& 0xFF;
	Buffer1[2]= (DataSize >>  8)& 0xFF;
	Buffer1[3]= (DataSize )& 0xFF;
	Buffer1[4]= 0;
	UART0_tx_str(Buffer1, 4);

	/* H8ŃG[f ʎM */
	stmp = UART0_rx(0);		// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0x00){		// 0x00M
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error7\0");
		while(1);	// ======================================> loop
	}

	/* ݻ4byte LCD\ */
	lcd_cmd(0x02);	// Cursor At Home
	lcd_str("SIZE=\0");
	Buffer1[0]= (DataSize >> 16)& 0xFF;	// [\
	Buffer1[1]= (DataSize >>  8)& 0xFF;
	Buffer1[2]= (DataSize )& 0xFF;
	lcd_binto16(Buffer1,3);	// binary=316i6ϊ
	lcd_str("    \0");

	/* uMJnvv M */
	stmp = UART0_rx(0);	// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0x11){	// 0x00M
		lcd_cmd(0x02);				// Cursor At Home
		lcd_str("Error8\0");
		while(1);	// ======================================> loop
	}

	/* 128byte ÂްM */
	ultmp = (unsigned long)(DataStart+(ClusterNum-2)*SectorsPerCluster)*512;	// address
	send =0;
	send_cluster =0;
	while ( send < DataSize ){		// rootdirectory瓾t@CTCY
		for (i=0; i<16; i++){

			if (send_cluster >= (SectorsPerCluster*512)){	// f[^NX^TCY
				send_cluster =0;
				ReadClusterChain(&ClusterChainNum);			// NX^`F[T
				//lcd_cmd(0x02);	// Cursor At Home
				//ltostring(6, ClusterNum, Buffer1);
				//lcd_str(Buffer1);
				//ltostring(6, ClusterChainNum, Buffer1);	// NX^`F[ԍ\
				//lcd_str(Buffer1);
				ultmp = (unsigned long)(DataStart+(ClusterChainNum-2)*SectorsPerCluster)*512;
			}

			if (read_32add512( ultmp, i)){	// AhX:512byte PʁAǍ32byte
				lcd_cmd(0x02);				// Cursor At Home
				lcd_str("Error9\0");
				while(1);	// ======================================> loop
			}

			if ( (DataSize - send) <= 32){
				stmp = DataSize - send;
			}else{
				stmp = 32;
			}
			UART0_tx_str(DataBuff, stmp);
			send_cluster += stmp;
			send += stmp;
			if (send == DataSize) break; // ===============================> end

			/* 128byte  H8uMJnvvM */
			if ( (i & 0x03)==0x03){		// 128 = 4 * 32
				stmp = UART0_rx(0);		// 100:timeOut 480us ,0͂Ƒ҂
				if (stmp != 0x11){
					lcd_cmd(0x02);		// Cursor At Home
					lcd_str("Error10\0");
					while(1);		// ======================================> loop
				}
			}
		}
		ultmp += 512;

		/* Mςݏް\ */
		Buffer1[0]= (send >> 16)& 0xFF;	// [\
		Buffer1[1]= (send >>  8)& 0xFF;
		Buffer1[2]= (send )& 0xFF;
		lcd_cmd(0xC0);	//Qs
		lcd_str("DATA=\0");
		lcd_binto16(Buffer1,3);
	}

	stmp = UART0_rx(0);	// 100:timeOut 480us ,0͂Ƒ҂
	if (stmp != 0xAA){	// H8ݐI M
		lcd_str("Error11\0");
		while(1);	// ======================================> loop
	}else{
		lcd_str("FINISH!\0");
	}

	while(1);

}

